package com.hfkj.dao;

import com.hfkj.entity.BsAgentApiLog;
import com.hfkj.entity.BsAgentApiLogExample;
import com.hfkj.entity.BsAgentApiLogWithBLOBs;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsAgentApiLogMapper extends BsAgentApiLogMapperExt {
    @SelectProvider(type=BsAgentApiLogSqlProvider.class, method="countByExample")
    long countByExample(BsAgentApiLogExample example);

    @DeleteProvider(type=BsAgentApiLogSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsAgentApiLogExample example);

    @Delete({
        "delete from bs_agent_api_log",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_agent_api_log (app_id, request_id, ",
        "request_url, create_time, ",
        "ext_1, ext_2, ext_3, ",
        "request_param, response_param, ",
        "error_content)",
        "values (#{appId,jdbcType=VARCHAR}, #{requestId,jdbcType=VARCHAR}, ",
        "#{requestUrl,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR}, ",
        "#{requestParam,jdbcType=LONGVARCHAR}, #{responseParam,jdbcType=LONGVARCHAR}, ",
        "#{errorContent,jdbcType=LONGVARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsAgentApiLogWithBLOBs record);

    @InsertProvider(type=BsAgentApiLogSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsAgentApiLogWithBLOBs record);

    @SelectProvider(type=BsAgentApiLogSqlProvider.class, method="selectByExampleWithBLOBs")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="app_id", property="appId", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_id", property="requestId", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_url", property="requestUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_param", property="requestParam", jdbcType=JdbcType.LONGVARCHAR),
        @Result(column="response_param", property="responseParam", jdbcType=JdbcType.LONGVARCHAR),
        @Result(column="error_content", property="errorContent", jdbcType=JdbcType.LONGVARCHAR)
    })
    List<BsAgentApiLogWithBLOBs> selectByExampleWithBLOBs(BsAgentApiLogExample example);

    @SelectProvider(type=BsAgentApiLogSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="app_id", property="appId", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_id", property="requestId", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_url", property="requestUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsAgentApiLog> selectByExample(BsAgentApiLogExample example);

    @Select({
        "select",
        "id, app_id, request_id, request_url, create_time, ext_1, ext_2, ext_3, request_param, ",
        "response_param, error_content",
        "from bs_agent_api_log",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="app_id", property="appId", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_id", property="requestId", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_url", property="requestUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_param", property="requestParam", jdbcType=JdbcType.LONGVARCHAR),
        @Result(column="response_param", property="responseParam", jdbcType=JdbcType.LONGVARCHAR),
        @Result(column="error_content", property="errorContent", jdbcType=JdbcType.LONGVARCHAR)
    })
    BsAgentApiLogWithBLOBs selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsAgentApiLogSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsAgentApiLogWithBLOBs record, @Param("example") BsAgentApiLogExample example);

    @UpdateProvider(type=BsAgentApiLogSqlProvider.class, method="updateByExampleWithBLOBs")
    int updateByExampleWithBLOBs(@Param("record") BsAgentApiLogWithBLOBs record, @Param("example") BsAgentApiLogExample example);

    @UpdateProvider(type=BsAgentApiLogSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsAgentApiLog record, @Param("example") BsAgentApiLogExample example);

    @UpdateProvider(type=BsAgentApiLogSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsAgentApiLogWithBLOBs record);

    @Update({
        "update bs_agent_api_log",
        "set app_id = #{appId,jdbcType=VARCHAR},",
          "request_id = #{requestId,jdbcType=VARCHAR},",
          "request_url = #{requestUrl,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR},",
          "request_param = #{requestParam,jdbcType=LONGVARCHAR},",
          "response_param = #{responseParam,jdbcType=LONGVARCHAR},",
          "error_content = #{errorContent,jdbcType=LONGVARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKeyWithBLOBs(BsAgentApiLogWithBLOBs record);

    @Update({
        "update bs_agent_api_log",
        "set app_id = #{appId,jdbcType=VARCHAR},",
          "request_id = #{requestId,jdbcType=VARCHAR},",
          "request_url = #{requestUrl,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsAgentApiLog record);
}