package com.hfkj.dao;

import com.hfkj.entity.BsDiscountUser;
import com.hfkj.entity.BsDiscountUserExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsDiscountUserMapper extends BsDiscountUserMapperExt {
    @SelectProvider(type=BsDiscountUserSqlProvider.class, method="countByExample")
    long countByExample(BsDiscountUserExample example);

    @DeleteProvider(type=BsDiscountUserSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsDiscountUserExample example);

    @Delete({
        "delete from bs_discount_user",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_discount_user (user_id, user_phone, ",
        "discount_id, discount_no, ",
        "discount_name, discount_type, ",
        "discount_condition, discount_price, ",
        "discount_stock_code, use_scope, ",
        "use_date, expiration_date, ",
        "agent_appid, `status`, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{userId,jdbcType=BIGINT}, #{userPhone,jdbcType=VARCHAR}, ",
        "#{discountId,jdbcType=BIGINT}, #{discountNo,jdbcType=VARCHAR}, ",
        "#{discountName,jdbcType=VARCHAR}, #{discountType,jdbcType=INTEGER}, ",
        "#{discountCondition,jdbcType=DECIMAL}, #{discountPrice,jdbcType=DECIMAL}, ",
        "#{discountStockCode,jdbcType=BIGINT}, #{useScope,jdbcType=VARCHAR}, ",
        "#{useDate,jdbcType=TIMESTAMP}, #{expirationDate,jdbcType=TIMESTAMP}, ",
        "#{agentAppid,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsDiscountUser record);

    @InsertProvider(type=BsDiscountUserSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsDiscountUser record);

    @SelectProvider(type=BsDiscountUserSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_phone", property="userPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_no", property="discountNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_name", property="discountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_type", property="discountType", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_condition", property="discountCondition", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_stock_code", property="discountStockCode", jdbcType=JdbcType.BIGINT),
        @Result(column="use_scope", property="useScope", jdbcType=JdbcType.VARCHAR),
        @Result(column="use_date", property="useDate", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="expiration_date", property="expirationDate", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="agent_appid", property="agentAppid", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsDiscountUser> selectByExample(BsDiscountUserExample example);

    @Select({
        "select",
        "id, user_id, user_phone, discount_id, discount_no, discount_name, discount_type, ",
        "discount_condition, discount_price, discount_stock_code, use_scope, use_date, ",
        "expiration_date, agent_appid, `status`, create_time, update_time, ext_1, ext_2, ",
        "ext_3",
        "from bs_discount_user",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_phone", property="userPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_no", property="discountNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_name", property="discountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_type", property="discountType", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_condition", property="discountCondition", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_stock_code", property="discountStockCode", jdbcType=JdbcType.BIGINT),
        @Result(column="use_scope", property="useScope", jdbcType=JdbcType.VARCHAR),
        @Result(column="use_date", property="useDate", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="expiration_date", property="expirationDate", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="agent_appid", property="agentAppid", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsDiscountUser selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsDiscountUserSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsDiscountUser record, @Param("example") BsDiscountUserExample example);

    @UpdateProvider(type=BsDiscountUserSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsDiscountUser record, @Param("example") BsDiscountUserExample example);

    @UpdateProvider(type=BsDiscountUserSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsDiscountUser record);

    @Update({
        "update bs_discount_user",
        "set user_id = #{userId,jdbcType=BIGINT},",
          "user_phone = #{userPhone,jdbcType=VARCHAR},",
          "discount_id = #{discountId,jdbcType=BIGINT},",
          "discount_no = #{discountNo,jdbcType=VARCHAR},",
          "discount_name = #{discountName,jdbcType=VARCHAR},",
          "discount_type = #{discountType,jdbcType=INTEGER},",
          "discount_condition = #{discountCondition,jdbcType=DECIMAL},",
          "discount_price = #{discountPrice,jdbcType=DECIMAL},",
          "discount_stock_code = #{discountStockCode,jdbcType=BIGINT},",
          "use_scope = #{useScope,jdbcType=VARCHAR},",
          "use_date = #{useDate,jdbcType=TIMESTAMP},",
          "expiration_date = #{expirationDate,jdbcType=TIMESTAMP},",
          "agent_appid = #{agentAppid,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsDiscountUser record);
}