package com.hfkj.openapi.model.request;

import lombok.Data;
import org.hibernate.validator.constraints.Range;

import javax.validation.constraints.NotBlank;

/**
 * @className: RequestQueryDiscountListModel
 * @author: HuRui
 * @date: 2024/9/1
 **/
@Data
public class RequestPushPkDiscountModel {

    /**
     * appid
     */
    @NotBlank(message = "请求id必填项")
    private String reqId;

    /**
     * appid
     */
    @NotBlank(message = "appId必填项")
    private String appId;

    /**
     * 优惠券编号
     */
    @NotBlank(message = "券包编号必填项")
    private String discountPkNo;

    /**
     * 推送数量
     */
    @Range(min = 1, max = 50,message = "数量必须设置在1至50之内")
    private Integer number;

    /**
     * 电话
     */
    @NotBlank(message = "电话必填项")
    private String phone;

    /**
     * 签名参数
     */
    @NotBlank(message = "签名必填项")
    private String sign;

}
