package com.hfkj.service.gas;

import com.hfkj.entity.BsGasOrderReceipt;

import java.util.List;
import java.util.Map;

/**
 * @className: BsGasOrderReceiptService
 * @author: HuRui
 * @date: 2024/7/24
 **/
public interface BsGasOrderReceiptService {

    /**
     * 编辑数据
     * @param data
     */
    void editData(BsGasOrderReceipt data);

    /**
     * 申请
     * @param userReceiptId
     * @param orderNos
     */

    void applyReceipt(Long userReceiptId, List<String> orderNos);

    /**
     * 开票成功
     * @param applyNo
     */
    void success(String applyNo);

    /**
     * 开票失败
     * @param applyNo
     */
    void fail(String applyNo, String remark);

    /**
     * 查询详情
     * @param applyNo
     */
    BsGasOrderReceipt getDetail(String applyNo);

    /**
     * 查询详情
     * @param orderReceiptId
     * @return
     */
    BsGasOrderReceipt getDetail(Long orderReceiptId);

    /**
     * 查询列表
     * @param param
     * @return
     */
    List<BsGasOrderReceipt> getList(Map<String,Object> param);

}
